// Test multiple assigment
// $Id: t7.g,v 1.1 2002/02/06 11:49:53 malekith Exp $
extern_c void print_string(string);
extern_c void print_int(int);

void print_pair(*[int, int] p)
{
	let [x, y] = p in {
		print_string("[");
		print_int(x);
		print_string(",");
		print_int(y);
		print_string("] ");
	}
}

int main() export_as "main"
{
	int x = 1;
	int y = 2;

	print_pair([x,y]);
	[x,y] = [y,x];
	print_pair([x,y]);
	[x,y] = [y,x];
	print_pair([x,y]);

	*[int, int] p;
	p = [3,4];
	[x,y] = p;
	print_pair([x,y]);
	[x,y] = [y,x];
	print_pair([x,y]);

	let [a, b] = [x, y] in {
		x = b;
		y = a;
	}
	print_pair([x,y]);

	switch [x, y] {
	case [a, b]:
		x = b;
		y = a;
	}
	print_pair([x,y]);
	
	print_string(".\n");
	
	return 0;
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: [1,2] [2,1] [1,2] [3,4] [4,3] [3,4] [4,3] .
 */
